let file_exists f =
    try
        Unix.access f [Unix.F_OK]; true
    with Unix.Unix_error (_,_,_) -> false

let unlink_if_exists f =
    if file_exists f then
        Sys.remove f
    else
        ()

let recursive_unlink dirname =
    if Sys.command ("rm -rf " ^ dirname) <> 0 then
        Log.die ("Unable to recursively remove " ^ dirname)
    else ()

(* note: copy needs to be smart if second arg is a directory *)
let copy f1 f2 =
    if Sys.command ("cp " ^ f1 ^ " " ^ f2) <> 0 then
        Log.die ("Unable to copy: " ^ f1 ^ " --> " ^ f2)
    else ()

(* here, the second arg is always a dir *)
let copydir d1 d2 =
    if Sys.command ("cp -R " ^ d1 ^ " " ^ d2) <> 0 then
        Log.die ("Unable to copydir: " ^ d1 ^ " --> " ^ d2)
    else ()

let write_file str filename =
    let chan = open_out filename in
    output_string chan str;
    close_out chan

let write_file_opt stro filename =
    match stro with
        None -> ()
      | Some str -> write_file str filename

let mkdir d = Unix.mkdir d 0o755
